const jwt = require("jsonwebtoken")

module.exports = async (req, res, next) => {
    const authHeader = req.headers['authorization']
    const token = authHeader && authHeader.split(' ')[1]

    if(token === null) {
        return res.status(401).send({ code: 401, message: 'Unauthorized' })
    }
    jwt.verify(token, process.env.JWT_TOKEN, (err, user) => {
        if(err) {
            return res.status(401).send({ code: 401, message: 'Unauthorized' })
        }
        if(user.user_id !== 1) {
            return res.status(403).send({ code: 403, message: 'Forbidden' })
        }
        req.context = user
        next()
    })
    
}
