const jwt = require("jsonwebtoken")

module.exports = async (req, res, next) => {
    const authHeader = req.headers['authorization']
    let token = authHeader && authHeader.split(' ')[1]
    if(token === null) {
        return res.status(401).send({ code: 401, message: 'Unauthorized' })
    }
    jwt.verify(token, process.env.JWT_TOKEN, (err, user) => {
        if(err) {
            return res.status(401).send({ code: 401, message: 'Unauthorized' })
        }
        req.context = user
        next()
    })
    
}
