const jwt = require("jsonwebtoken")

module.exports = async (req, res, next) => {
    let token
    if(typeof token === 'undefined' && typeof req.cookies !== 'undefined' && typeof req.cookies['token'] !== 'undefined' && req.cookies.token !== '') {
        token = req.cookies['token']
    }
    else if(typeof req.query['access_token'] !== 'undefined' && req.query.access_token !== '') {
        token = req.query.access_token
    }
    if(token === null) {
        return res.status(401).send({ code: 401, message: 'Unauthorized' })
    }
    jwt.verify(token, process.env.JWT_TOKEN, (err, user) => {
        if(err) {
            return res.status(401).send({ code: 401, message: 'Unauthorized' })
        }
        req.context = user
        next()
    })
    
}
