const { Sequelize } = require("sequelize")
const { DB_NAME, DB_USER, DB_PASS, DB_HOST, DB_PORT, DB_LOG } = process.env;

const db = new Sequelize(DB_NAME, DB_USER, DB_PASS, {
    host: DB_HOST,
    port: DB_PORT || 3306,
    dialect: 'mysql',
    logging: DB_LOG === "true" || false,
    pool: {
        max: 10,
        min: 2,
        acquire: 60000,
        idle: 15000
    }
});

exports.dbStart = () => {
    db.authenticate()
    .then(() => console.log("DATABASE CONNECTED"))
    .catch(err => console.log("Error: ", err))
}
exports.orm = db;