const rTracer = require('cls-rtracer')
const { createLogger, format, transports } = require('winston')
const { combine, timestamp, printf } = format
const rTracerFormat = printf((info) => {
  const rid = rTracer.id()
  return rid
    ? `${info.timestamp} ${rid}: ${info.message}`
    : `${info.timestamp}: ${info.message}`
})

const logger = createLogger({
  format: combine(
    timestamp(),
    rTracerFormat
  ),
  transports: [new transports.Console()]
})

module.exports = {
  logger,
  rTracer
}