const ws = require('ws')

exports.establishConnection = (host, service_token) => {
    const vm = this
    return new Promise(function(resolve, reject) {
        var server = new ws(host, service_token);
        server.onopen = function() {
            console.log('Websocket is connected to host : ' + host)
            resolve(server);
        };
        server.onerror = function(err) {
            // console.log(`Can't connect to websocket ${host}`)
        };

        server.onclose = (e) => {
            vm.connect()
        };
    });
}

exports.connect = async() => {
    this.connection = await this.establishConnection(this.host, this.service_token)
}
exports.init = async ({ host, service_token }) => {
    try {
        this.host = host
        this.service_token = service_token
        this.connect()
    } catch (err) {
        throw new Error("FAILED_CONNETING_WS[2] : ",err)
    }
}

exports.close = () => {
    this.connection.close()
}

exports.sendMessage = async (data) => {
    try {
        await this.connection.send(JSON.stringify(data))
        return true

    } catch (err) {
        console.error('ERROR_WEBSOCKET_SEND_MESSAGE', err)
    }
}
